BigTableWriter (apache-cassandra API)
Date: 2018-02-12

org.apache.cassandra.io.sstable.format.big

## Class BigTableWriter

- java.lang.Object
- - org.apache.cassandra.io.sstable.SSTable
  - - org.apache.cassandra.io.sstable.format.SSTableWriter
    - - org.apache.cassandra.io.sstable.format.big.BigTableWriter

- All Implemented Interfaces:
    java.lang.AutoCloseable, Transactional

      public class BigTableWriter
      extends SSTableWriter

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.cassandra.io.sstable.format.SSTableWriter

      `SSTableWriter.Factory`

    - ### Nested classes/interfaces inherited from interface org.apache.cassandra.utils.concurrent.Transactional

      `Transactional.AbstractTransactional`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `END_OF_ROW`

    - ### Fields inherited from class org.apache.cassandra.io.sstable.format.SSTableWriter

      `keyCount, maxDataAge, metadataCollector, repairedAt, rowIndexEntrySerializer, txnProxy`

    - ### Fields inherited from class org.apache.cassandra.io.sstable.SSTable

      `components, compression, descriptor, first, last, metadata, partitioner, TOMBSTONE_HISTOGRAM_BIN_SIZE`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `RowIndexEntry` | `append(AbstractCompactedRow row)`
    `void` | `append(DecoratedKey decoratedKey, ColumnFamily cf)`
    `long` | `appendFromStream(DecoratedKey key, CFMetaData metadata, java.io.DataInput in, Version version)`
    `long` | `getFilePointer()`
    `long` | `getOnDiskFilePointer()`
    `void` | `mark()`
    `SSTableReader` | `openEarly()` Open the resultant SSTableReader before it has been fully written
    `SSTableReader` | `openFinalEarly()` Open the resultant SSTableReader once it has been fully written, but before the _set_ of tables that are being written together as one atomic operation are all ready
    `void` | `resetAndTruncate()`
    `protected SSTableWriter.TransactionalProxy` | `txnProxy()`

    - ### Methods inherited from class org.apache.cassandra.io.sstable.format.SSTableWriter

      `abort, abort, close, commit, create, create, create, create, create, create, finalizeMetadata, finish, finish, finished, prepareToCommit, rename, rename, setMaxDataAge, setOpenResult, setRepairedAt, statsMetadata`

    - ### Methods inherited from class org.apache.cassandra.io.sstable.SSTable

      `addComponents, appendTOC, bytesOnDisk, componentsFor, delete, discoverComponentsFor, estimateRowsFromIndex, getColumnFamilyName, getFilename, getIndexFilename, getKeyspaceName, getMinimalKey, readTOC, toString, tryComponentFromFilename`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### END_OF_ROW

          public static final int END_OF_ROW

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### mark

          public void mark()

      Specified by:
        `mark` in class `SSTableWriter`

    - #### resetAndTruncate

          public void resetAndTruncate()

      Specified by:
        `resetAndTruncate` in class `SSTableWriter`

    - #### append

          public RowIndexEntry append(AbstractCompactedRow row)

      Specified by:
        `append` in class `SSTableWriter`
      Parameters:
        `row` -
      Returns:
        null if the row was compacted away entirely; otherwise, the PK index entry for this row

    - #### append

          public void append(DecoratedKey decoratedKey,
                             ColumnFamily cf)

      Specified by:
        `append` in class `SSTableWriter`

    - #### appendFromStream

          public long appendFromStream(DecoratedKey key,
                                       CFMetaData metadata,
                                       java.io.DataInput in,
                                       Version version)
                                throws java.io.IOException

      Specified by:
        `appendFromStream` in class `SSTableWriter`
      Throws:
        `java.io.IOException` - if a read from the DataInput fails
        `FSWriteError` - if a write to the dataFile fails

    - #### openEarly

          public SSTableReader openEarly()

      Description copied from class: `SSTableWriter`
      Open the resultant SSTableReader before it has been fully written
      Specified by:
        `openEarly` in class `SSTableWriter`

    - #### openFinalEarly

          public SSTableReader openFinalEarly()

      Description copied from class: `SSTableWriter`
      Open the resultant SSTableReader once it has been fully written, but before the _set_ of tables that are being written together as one atomic operation are all ready
      Specified by:
        `openFinalEarly` in class `SSTableWriter`

    - #### txnProxy

          protected SSTableWriter.TransactionalProxy txnProxy()

      Specified by:
        `txnProxy` in class `SSTableWriter`

    - #### getFilePointer

          public long getFilePointer()

      Specified by:
        `getFilePointer` in class `SSTableWriter`

    - #### getOnDiskFilePointer

          public long getOnDiskFilePointer()

      Specified by:
        `getOnDiskFilePointer` in class `SSTableWriter`

Copyright © 2018 The Apache Software Foundation